 <?php
# https://valentin.dasdeck.com/projects/p2p_share/

#includes
require_once('inc/db.inc.php');

#config
$KEEPOPEN_MS = 10000; # 10 seconds
$SLEEP_MS = 1000; # 1 second
$KICKOUTDEAD_SEC = 300; # 5 minutes
$MAX_FILE_SIZE = 100*1024*1024; # 100 MB
$CHUNK_SIZE = 81920; # 80 Kb

# kick out dead peers
$sql = "DELETE FROM peers WHERE UNIX_TIMESTAMP(last_alive)<".(time()-$KICKOUTDEAD_SEC);
$db->db_query($sql);

# connect
if (isset($_GET['connect'])){
  $user_id = rand(100000000, 999999999);

  #todo: prevent (unlikely) random collisions, by checking existing user_ids in DB

  # insert peer
  $sql = "INSERT INTO peers(user_id) VALUES($user_id)";
  $db->db_query($sql);

  die("$user_id");
}

# disconnect
if (isset($_GET['disconnect'])){
  $user_id = (int)$_GET['disconnect'];

  # remove peer
  $sql = "DELETE FROM peers WHERE user_id=$user_id";
  $db->db_query($sql);

  # remove existing downloads
  $sql = "SELECT id FROM files WHERE receiver_id=$user_id";
  $res = $db->db_query($sql);
  while ($row = $db->db_fetch_assoc($res)){
    @unlink('uploads/'.$row['id']);
  }

  $sql = "DELETE FROM files WHERE sender_id=$user_id OR receiver_id=$user_id";
  $db->db_query($sql);
  exit;
}

# alive
if (isset($_GET['alive'])){
  $user_id = (int)$_GET['alive'];
  $sql = "UPDATE peers SET last_alive=NOW() WHERE user_id=$user_id";
  $db->db_query($sql);
  exit;
}

# check
if (isset($_GET['check'])){
  $user_id = (int)$_GET['check'];
  $sql = "SELECT id FROM peers WHERE user_id=$user_id";
  $res = $db->db_query($sql);
  if ($db->db_num_rows($res)) echo 'OK';
  exit;
}

$peer_id = (int)$_GET['id'];

# upload
if ($_SERVER['REQUEST_METHOD'] == "PUT"){

  $filesize = @$_SERVER['CONTENT_LENGTH'];
  if ($filesize>$MAX_FILE_SIZE) exit;

  $receiver_id = (int)$_GET['rcv'];
  $filename = $db->db_escape_string(basename($_GET['fn']));

  # save in DB
  $sql = "INSERT INTO files(sender_id,receiver_id,name,size) VALUES($peer_id,$receiver_id,'$filename',$filesize)";
  $db->db_query($sql);
  $file_id = $db->db_insert_id();
  $tmpfile = 'uploads/'.$file_id;

  $fp_put = fopen("php://input", 'r');

  stream_set_chunk_size ($fp_put, $CHUNK_SIZE);

  $fp = fopen($tmpfile, 'c+');

  $bytes = 0;

  while ($data = fread($fp_put, $CHUNK_SIZE)){
    flock($fp, LOCK_EX);
    $bytes += fwrite($fp, $data);
    flock($fp, LOCK_UN);
  }

  fclose($fp);
  fclose($fp_put);

  # update status in DB
  $sql = "UPDATE files SET final_size=$bytes,finished=1 WHERE id=$file_id";
  $db->db_query($sql);

  exit;
}

# check for new downloads
$keepOpenUntil = microtime(true) + $KEEPOPEN_MS/1000;
while (microtime(true)<=$keepOpenUntil){

  # check if there is a new download
  $sql = "SELECT * FROM files WHERE receiver_id=$peer_id";
  $res = $db->db_query($sql);
  if ($row = $db->db_fetch_assoc($res)){

    # start new download
    $sender_id = $row['sender_id'];
    $file_id = $row['id'];
    $tmpfile = 'uploads/'.$file_id;
    $filename = $row['name'];
    $filesize = $row['size'];
    $finished = false;

    header("Sender: $sender_id");
    header("Filename: $filename");
    header("Content-Length: $filesize");
    header('Content-Transfer-Encoding: binary');

    $fp = fopen($tmpfile, 'r');

    while (true){

      flock($fp, LOCK_SH);
      $data = fread($fp, $CHUNK_SIZE);
      $pos = ftell($fp);
      flock($fp, LOCK_UN);

      if ($data) echo $data;

      # check if status has changed
      if (!$finished){
        $sql = "SELECT * FROM files WHERE id=$file_id";
        $res = $db->db_query($sql);
        $row = $db->db_fetch_assoc($res);
        if ($row['finished']){
          $finished = true;
          $filesize = $row['final_size'];
        }
      }

      if ($pos>=$filesize){
        fclose($fp);

        # delete tmp file
        unlink($tmpfile);

        # remove from DB
        $sql = "DELETE FROM files WHERE id=$file_id";
        $db->db_query($sql);

        exit;
      }
    }
  }

  usleep($SLEEP_MS*1000);
}
