--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      LSW CORE LIB: DROP
-- @author    Valentin Schmidt
-- @version   0.2
-- @requires  xtra("DropXtra")
--****************************************************************************

property ancestor
property _handler
property _target

--xtra DropXtra
--new object me, symbol callbackHandler, *callbackTarget
--dropStart object me, *hwnd
--dropStop object me, *hwnd

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

  -- libs
  me.$.import("detacher")

  me.$.loadXtras(me.libdir, ["DropXtra.x32"], ["DropXtra.xtra"])
  --put xtra("DropXtra").interface()

  me.ancestor = xtra("DropXtra").new(#_itemsDropped, me)

  return me
end

----------------------------------------
-- @callback
----------------------------------------
on _itemsDropped (me, tItems)
  if symbolP(me._handler) then
    me.$.detacher.detach(me._handler, me._target, tItems)
  end if
end

----------------------------------------
-- Adds callback for Drop events
-- @param {symbol} cbHandler
-- @param {object} [cbTarget=_movie]
----------------------------------------
on setCallback (me, cbHandler, cbTarget)
  if voidp(cbTarget) then cbTarget = _movie
  me._handler = cbHandler
  me._target = cbTarget
end

----------------------------------------
-- Starts handling of drop events
----------------------------------------
on start (me)
  me.dropStart()
end

----------------------------------------
-- Stops handling of drop events
----------------------------------------
on stop (me)
  me.dropStop()
end
