--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: TIMER
-- @author   	Valentin Schmidt
-- @version  	0.2
-- @desc
-- Interface for creation of Lingo timeout object wrappers. 
-- Supports single-shot mode and passing custom arguments.
--****************************************************************************

property $

property _wrapper
property _cnt

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
	me._wrapper = $.include(me.libdir&"timeout_wrapper.ls")
	me._cnt = 0
	return me
end

----------------------------------------
-- Factory method: creates and returns a new wrapped/augmented timeout object
--
-- @param {integer} tPeriod
-- @param {symbol} tCbHandler
-- @param {object} [tCbObject=_movie]
-- @param {bool} [tSingleShotFlag=false]
-- @param {mixed} [p1]
-- @param {mixed} [p2]
-- @param {mixed} [p3]
-- @param {mixed} [p4]
-- @return {instance}
-- @usage
-- $.timer.create(3000, #foo, _movie, true, 23, 666)
----------------------------------------
on create (me, tPeriod, tCbHandler, tCbObject, tSingleShotFlag, p1, p2, p3, p4)
	me._cnt = me._cnt + 1
	return me._wrapper.new(string(me._cnt), tPeriod, tCbHandler, tCbObject, tSingleShotFlag, p1, p2, p3, p4)
end
